/** 
 *******************************************************************************
 * @file    i2c_eeprom.h
 * @brief   This file provides all the functions prototypes for I2C EEPROM.
 * @version V1.0.0
 * 
 * DO NOT USE THIS SOFTWARE WITHOUT THE SOFTWARE LICENSE AGREEMENT.
 * 
 * Copyright(C) Toshiba Electronic Device Solutions Corporation 2020
 *******************************************************************************
 */
/*------------------------------------------------------------------------------*/
/*  Define to prevent recursive inclusion                                       */
/*------------------------------------------------------------------------------*/
#ifndef __I2C_EEPROM_H
#define __I2C_EEPROM_H

#ifdef __cplusplus
extern "C" {
#endif

/*------------------------------------------------------------------------------*/
/*  Includes                                                                    */
/*------------------------------------------------------------------------------*/
#include "txz_sample_def.h"

/**
 *  @addtogroup Example
 *  @{
 */

/** 
 *  @addtogroup I2C_EEPROM
 *  @{
 */
/*------------------------------------------------------------------------------*/
/*  Macro Definition                                                            */
/*------------------------------------------------------------------------------*/
/** 
 *  @addtogroup I2C_EEPROM_Private_define
 *  @{
 */

/* no define */

/** 
 *  @}
 */ /* End of group I2C_EEPROM_Private_define */
 
/*------------------------------------------------------------------------------*/
/*  Enumerated Type Definition                                                  */
/*------------------------------------------------------------------------------*/
/** 
 *  @addtogroup I2C_EEPROM_Private_define
 *  @{
 */

/* no define */

/** 
 *  @}
 */ /* End of group I2C_EEPROM_Private_define */

/*------------------------------------------------------------------------------*/
/*  Structure Definition                                                        */
/*------------------------------------------------------------------------------*/
/** 
 *  @addtogroup I2C_EEPROM_Private_typedef
 *  @{
 */

/* no define */

/**
 *  @}
 */ /* End of group I2C_EEPROM_Private_typedef */


/*------------------------------------------------------------------------------*/
/*  Functions                                                                   */
/*------------------------------------------------------------------------------*/
/** 
 *  @addtogroup I2C_EEPROM_Exported_functions
 *  @{
 */
TXZ_Result EEPROM_i2c_init(void);
TXZ_Result EEPROM_i2c_ReadByte(int32_t address, uint8_t *p_data);
TXZ_Result EEPROM_i2c_WriteByte(int32_t address, uint8_t data);
int32_t EEPROM_i2c_ReadData(int32_t address, uint8_t *p_data, int32_t length);
int32_t EEPROM_i2c_WritePage(int32_t address, uint8_t *p_data, int32_t length);
TXZ_Result EEPROM_i2c_WriteProtection(void);
int32_t EEPROM_i2c_IsDeviceReady(void);

/**
 *  @}
 */ /* End of group I2C_EEPROM_Exported_functions */
/**
 *  @}
 */ /* End of group I2C_EEPROM */

/**
 *  @}
 */ /* End of group Example */

#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* I2C_EEPROM_H */
