/** 
 *******************************************************************************
 * @file    IOSCadjustment.h
 * @brief   This file provides all the functions prototypes for the IOSC adjustment.
 * @version V1.0.0
 * 
 * DO NOT USE THIS SOFTWARE WITHOUT THE SOFTWARE LICENSE AGREEMENT.
 * 
 * Copyright(C) Toshiba Electronic Device Solutions Corporation 2020
 *******************************************************************************
 */
/*------------------------------------------------------------------------------*/
/*  Define to prevent recursive inclusion                                       */
/*------------------------------------------------------------------------------*/
#ifndef __IOSCADJUSTMENT_H
#define __IOSCADJUSTMENT_H

#ifdef __cplusplus
extern "C" {
#endif

/*------------------------------------------------------------------------------*/
/*  Includes                                                                    */
/*------------------------------------------------------------------------------*/
#include "txz_sample_def.h"

/**
 *  @addtogroup Example
 *  @{
 */

/** 
 *  @addtogroup TRMOSC
 *  @{
 */
/*------------------------------------------------------------------------------*/
/*  Macro Function                                                              */
/*------------------------------------------------------------------------------*/
/** 
 *  @addtogroup TRMOSC_Private_macro
 *  @{
 */

/* no define */

/** 
 *  @}
 */ /* End of group TRMOSC_Private_macro */


/*------------------------------------------------------------------------------*/
/*  Configuration                                                               */
/*------------------------------------------------------------------------------*/
/** 
 *  @addtogroup TRMOSC_Private_define
 *  @{
 */

/* no define */

/** 
 *  @}
 */ /* End of group TRMOSC_Private_define */


/*------------------------------------------------------------------------------*/
/*  Macro Definition                                                            */
/*------------------------------------------------------------------------------*/
/** 
 *  @addtogroup TRMOSC_Private_define
 *  @{
 */

#define TRMOSC_RUN             (1)             /*!< run   */
#define TRMOSC_DONE            (0)             /*!< done  */
#define TRMOSC_ERROR           (-1)            /*!< error */

/**
 *  @}
 */ /* End of group TRMOSC_Control */

/** 
 *  @}
 */ /* End of group TRMOSC_Private_define */

/*------------------------------------------------------------------------------*/
/*  Enumerated Type Definition                                                  */
/*------------------------------------------------------------------------------*/
/** 
 *  @addtogroup TRMOSC_Private_define
 *  @{
 */

/* no define */

/** 
 *  @}
 */ /* End of group TRMOSC_Private_define */

/*------------------------------------------------------------------------------*/
/*  Structure Definition                                                        */
/*------------------------------------------------------------------------------*/
/** 
 *  @defgroup TRMOSC_Private_typedef
 *  @{
 */
/*----------------------------------*/
/** 
 * @brief Adjustment Information.
*/
/*----------------------------------*/
typedef struct
{
    uint32_t MeasureVal;
    int32_t  MeasureDiff;
    uint32_t  Trim;
} IOSCADJ_TypeDef;

/**
 *  @}
 */ /* End of group TRMOSC_Private_define */

/*------------------------------------------------------------------------------*/
/*  Functions                                                                   */
/*------------------------------------------------------------------------------*/
/** 
 *  @addtogroup TRMOSC_Private_functions
 *  @{
 */

int32_t IOSCAdjustment(void);
void InitTRM(void);

/** 
 *  @}
 */ /* End of group TRMOSC_Private_functions */

/**
 *  @}
 */ /* End of group TRMOSC */

/**
 *  @} 
 */ /* End of group Example */

#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* __IOSCADJUSTMENT_H */

