/**
 *******************************************************************************
 * @file    txz_sample_def.h
 * @brief   This file includes header files for sample application.
 * @version V1.0.0
 * 
 * DO NOT USE THIS SOFTWARE WITHOUT THE SOFTWARE LICENSE AGREEMENT.
 * 
 * Copyright(C) Toshiba Electronic Device Solutions Corporation 2020
 *******************************************************************************
 */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __TXZ_SAMPLE_DEF_H
#define __TXZ_SAMPLE_DEF_H

#define TRMOSC_SAMPLE
/*#define TRMOSC_LOSC*/

#include "txz_driver_def.h"
#include "txz_gpio.h"
#include "txz_t32a.h"
#include "txz_uart.h"
#include "trm.h"
#include "txz_cg.h"


  #ifdef TRMOSC_LOSC
    #define BSP_T32A_REFIN                 TSB_T32A8
    #define BSP_T32A_REFIN_RUNA_SFTSTAA    TSB_T32A8_RUNA_SFTSTAA
    #define BSP_T32A_REFIN_RUNB_SFTSTPB    TSB_T32A8_RUNB_SFTSTPB
  #else
    #define BSP_T32A_REFIN                 TSB_T32A2
    #define BSP_T32A_REFIN_RUNA_SFTSTPA    TSB_T32A2_RUNA_SFTSTPA
  #endif
    #define BSP_T32A_SOUT                  TSB_T32A0
    #define BSP_T32A_SOUT_RUNA_SFTSTAA     TSB_T32A0_RUNA_SFTSTAA

#endif  /* __TXZ_SAMPLE_DEF_H */
